<?php
require_once('auth.php');
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>RRZE NavEditor 2.0 - Prototype</title>
<link rel="stylesheet" type="text/css" href="css/styles.css" />

<script type="text/javascript" src="tiny_mce/tiny_mce.js"></script>
<script type="text/javascript">
tinyMCE.init({
	mode: "textareas",
	theme: "advanced",
	plugins: "inlinepopups,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,insertdatetime,preview,zoom,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras",
	theme_advanced_toolbar_location: "top",
	theme_advanced_toolbar_align: "left",
	theme_advanced_statusbar_location: "bottom",
	convert_urls: false
});
</script>

<script type="text/javascript" src="js/jquery-1.2.6.pack.js"></script>
<script type="text/javascript" src="js/jquery.rightClick.js"></script>
<script type="text/javascript" src="js/json2.js"></script>
<script type="text/javascript" src="js/naveditor2.js"></script>

<script type="text/javascript">
<!--
var g_newKey = "";
var g_hasFocus = false;

function loadTreeCallback(jsonTreeData)
{
	navTreeOper.refreshNavTree(jsonTreeData);
	resetTextBox();
}

function getContentCallback(data)
{
	var rdata = data.replace(/<comment_ssi>/g, "<!-" + "-#");
	rdata = rdata.replace(/<comment>/g, "<!-" + "-");
	rdata = rdata.replace(/<\/comment>/g, "-" + "->");
	tinyMCE.get("txtContent").setContent(rdata);
}

function getBackupListCallback(data) {
	opt = "<option value=\"0\" selected=\"selected\">-- Backup-Liste --</option>";
	for(var i = 0; i < data.length; i++) {
		opt += "<option value=\"" + data[i].file_name + "\">" + data[i].file_name + "</option>";
	}
	$("#selOldVersions").empty();
	$("#selOldVersions").append(opt);
}

function treeNodeClick(nodeKey)
{
		$("#" + navTreeOper.dirHtmlPanelId + " ul li span").removeClass("currentSelected");
		$("#" + nodeKey).find("span").addClass("currentSelected"); // highlight li
		
		var cKey = nodeKey;
		navTreeOper.setCurrentKey(cKey);
		
		var cNode = navTreeOper.locateNode(cKey);
		navTreeOper.setCurrentNode(cNode);
		
		if(navTreeOper.getCurrentNode() == null) {
			alert("ERROR: Current-Node is null!");
			return;
		}
		
		// update textboxs
		$("#txtTitle").attr("value", cNode.title);
		$("#txtAlias").attr("value", cNode.alias);
		$("#txtUrl").attr("value", cNode.url);
		$("#txtInfotext").attr("value", cNode.info_text);
		if(cNode.quicklink) {
			$("#chkQuickLink").attr("checked", "checked");
		} else {
			$("#chkQuickLink").removeAttr("checked");
		}		
		
		cNode.path = navTreeOper.getPathInfo(cNode);
		$.get("app/update_contents.php?r=" + Math.random(), {
			"json_oper": "get_content",
			"json_data": JSON.stringify(cNode)
		}, getContentCallback);
		
		// get backup file list
		$.getJSON("app/update_contents.php?r=" + Math.random(), {
			"json_oper": "get_backup_list",
			"json_data": JSON.stringify(cNode)
		}, getBackupListCallback);
		
		navTreeOper.updateButtons();
		
		$("#" + navTreeOper.debugInfoPanelId).text(navTreeOper._currentKey + ": " + navTreeOper._currentNode.title);
		// preview link
		$("#lnkPreview").attr("target", "_blank");
		$("#lnkPreview").attr("href", cNode.path);
		
		g_hasFocus = true;
}

function doRecoveryCallback(data) {
	var rdata = data.split("_");
	alert(rdata[0]);
	treeNodeClick(rdata[1]);
}

function doRecovery() {
	var bak_file_name = $("#selOldVersions").val();
	if(bak_file_name != "0") {
		var cNode = navTreeOper.getCurrentNode();
		cNode.path = navTreeOper.getPathInfo(cNode);
		$.post("app/update_contents.php?r=" + Math.random(), {
			"json_oper": "recover",
			"json_data": JSON.stringify(cNode),
			"backup_file_name": bak_file_name
		}, doRecoveryCallback);
	}
}

function registerDirNodeEvents()
{
	$("#" + navTreeOper.dirHtmlPanelId + " ul li").click(function() {
		var ckey = $(this).attr("id");
		treeNodeClick(ckey);
	});
	
	$("#" + navTreeOper.dirHtmlPanelId + " ul li").rightClick(function(el) {
		var ckey = $(el).attr("id");
		treeNodeClick(ckey);
		showQuickNodeOperMenu(ckey);
	});
	
	$("#" + navTreeOper.dirHtmlPanelId + " ul li").noContext();
}

function showQuickNodeOperMenu(nodeKey) {
//	alert(nodeKey);
}

function saveTreeDataCallback(data)
{
	alert(data);
	g_hasFocus = false;
}

function resetTextBox()
{
	$("#txtTitle").attr("value", "");
	$("#txtAlias").attr("value", "");
	$("#txtContent").val("");
	if(tinyMCE.get("txtContent")) {
		tinyMCE.get("txtContent").setContent("");
	}
	$("#txtUrl").attr("value", "");
	$("#txtInfotext").attr("value", "");
	
	$("#lnkPreview").attr("target", "_self");
	$("#lnkPreview").attr("href", "javascript:;");
}

function addNodeCallback(data)
{
	alert(data);
	resetTextBox();
	if(g_newKey != "") {
		treeNodeClick(g_newKey);
	}
	btnSaveTreeClick();
}

function removeCallback(data)
{
	alert(data);
	resetTextBox();
	btnSaveTreeClick();
	g_hasFocus = false;
}

function updateContentsCallback(data)
{
	alert(data);
	navTreeOper.refreshNavTree(navTreeOper.getJSONObject());
	resetTextBox();
	if(g_newKey != "") {
		treeNodeClick(g_newKey);
	}
	btnSaveTreeClick();
}

function btnStartClick()
{
	$.getJSON("app/load_tree_data.php?r=" + Math.random(), loadTreeCallback); // load tree data
}

function btnSaveTreeClick()
{
	var normalNodes = (navTreeOper.getJSONObject()).A;
	navTreeOper.addPathInfo(normalNodes);
	$.post("app/save_tree_data.php", {
		"jsonTreeData": JSON.stringify(navTreeOper.getJSONObject())
	});
}

function filter(source)
{
	var fname = source;
	fname = fname.toLowerCase();
	
//	fname = fname.replace("ß", "ss");
//	fname = fname.replace("ä", "ae");
//	fname = fname.replace("ö", "oe");
//	fname = fname.replace("ü", "ue");
	fname = fname.replace(/\u00df/, "ss");
	fname = fname.replace(/\u00e4/, "ae");
	fname = fname.replace(/\u00f6/, "oe");
	fname = fname.replace(/\u00fc/, "ue");
	fname = fname.replace(/([^\w.\-_])/g, "");
	
	return fname;
}

/* ---------- Here comes jQuery: ---------- */
$(document).ready(function() {
	/* TreeObj init... */
	navTreeOper.debugInfoPanelId = "debug";
	navTreeOper.dirDivIdNormal = "pnlNormal";
	navTreeOper.dirDivIdExtra = "pnlExtra";
	navTreeOper.dirDivIdSpec = "pnlSpec";
	navTreeOper.dirHtmlPanelId = "dirTreePanel";
	navTreeOper.nodeEventFuncName = "registerDirNodeEvents();"; // reg. events
	navTreeOper.init();
	
	resetTextBox();
	
	// display ajax error info.
	$("#debug").ajaxError(function(event, request, settings) {
		$(this).html("<span style='color:red;'>Error requesting page " + settings.url + "</span>");
	});
	
/*	$("#btnStart").click(function() {
		$.getJSON("app/load_tree_data.php", loadTreeCallback); // load tree data
	});*/
	
	$("#btnSaveTree").click(function() {
		if(confirm("Are you sure to save entire Nav-Tree?")) {
			var normalNodes = (navTreeOper.getJSONObject()).A;
			navTreeOper.addPathInfo(normalNodes);
			$.post("app/save_tree_data.php", {
				"jsonTreeData": JSON.stringify(navTreeOper.getJSONObject())
			}, saveTreeDataCallback);
		}
	});
	
	$("#btnAddSibling").click(function() {
		var newSiblingTitle = prompt("Titel?", "Neuer Titel");
		if(newSiblingTitle) {
			var snode = navTreeOper.addSibling(newSiblingTitle);
			snode.path = navTreeOper.getPathInfo(snode);
			g_newKey = snode.key;
			var templname = $("#selTempl").val();
			$.post("app/update_contents.php", {
				"json_oper": "create_sibling",
				"json_data": JSON.stringify(snode),
				"template_file": templname
			}, addNodeCallback);
		}
	});
	
	$("#btnNewExtraNode").click(function() {
		var newExtraNodeTitle = prompt("Titel?", "Neuer Titel");
		if(newExtraNodeTitle) {
			navTreeOper.setCurrentKey("Z0");
			navTreeOper.setCurrentNodeGroup("Z");
			var snode = navTreeOper.addSibling(newExtraNodeTitle);
			g_newKey = snode.key;
			snode.path = navTreeOper.getPathInfo(snode);
			var templname = $("#selTempl").val();
			$.post("app/update_contents.php", {
				"json_oper": "create_sibling",
				"json_data": JSON.stringify(snode),
				"template_file": templname
			}, addNodeCallback);
		}
	});
	
	$("#btnNewSpecNode").click(function() {
		var newSpecNodeTitle = prompt("Titel?", "Neuer Titel");
		if(newSpecNodeTitle) {
			navTreeOper.setCurrentKey("S0");
			navTreeOper.setCurrentNodeGroup("S");
			var snode = navTreeOper.addSibling(newSpecNodeTitle);
			g_newKey = snode.key;
			snode.path = navTreeOper.getPathInfo(snode);
			var templname = $("#selTempl").val();
			$.post("app/update_contents.php", {
				"json_oper": "create_sibling",
				"json_data": JSON.stringify(snode),
				"template_file": templname
			}, addNodeCallback);
		}
	});
	
	$("#btnAddChild").click(function() {
		var newChildTitle = prompt("Titel?", "Neuer Titel");
		if(newChildTitle) {
			var onode = navTreeOper.getCurrentNode();
			var opath = navTreeOper.getPathInfo(onode);
			var cnode = navTreeOper.addChild(newChildTitle);
			g_newKey = cnode.key;
			cnode.path = navTreeOper.getPathInfo(cnode);
			var templname = $("#selTempl").val();
			$.post("app/update_contents.php", {
				"json_oper": "create_child",
				"json_data": JSON.stringify(cnode),
				"parent_node_path": opath,
				"template_file": templname
			}, addNodeCallback);
		}
	});
	
	$("#btnRemove").click(function() {
		if(confirm("Are you sure to remove this node?")) {
			var cnode = navTreeOper.getCurrentNode();
			navTreeOper.addPathInfo(cnode);
			navTreeOper.remove();
			$.post("app/update_contents.php", {
				"json_oper": "remove",
				"json_data": JSON.stringify(cnode)
			}, removeCallback);
		}
	});
	
	$("#btnCut").click(function() {
/*		if(confirm("Are you sure?")) {
			navTreeOper.cut();
		}*/
		alert("INFO: This function is not implemented yet, sorry.");
	});
	
	$("#btnPaste0").click(function() {
/*		navTreeOper.pasteAsSibling();*/
		alert("INFO: This function is not implemented yet, sorry.");
	});
	
	$("#btnPaste1").click(function() {
/*		navTreeOper.pasteAsChild();*/
		alert("INFO: This function is not implemented yet, sorry.");
	});
	
	$("#btnUpdate").click(function() {
		if(!g_hasFocus) {
			alert("Please select a node first!");
			return;
		}
		var ttl = $("#txtTitle").attr("value");
		var als = $("#txtAlias").attr("value");
		var url = $("#txtUrl").attr("value");
		var ift = $("#txtInfotext").attr("value");
		if(ttl == "" || ttl == undefined) {
			alert("Title cannot be empty!");
			return;
		}
		
		var crnode = navTreeOper.getCurrentNode();
		if(crnode == null) {
			alert("ERROR: Current-Node is null!");
			return;
		}
		
		g_newKey = crnode.key;

//		var cnt = $("#txtContent").val();
		var cnt = tinyMCE.get("txtContent").getContent();
		cnt = cnt.replace(new RegExp("<!-" + "-#", "g"), "<comment_ssi>")
		cnt = cnt.replace(/<!--/g, "<comment>")
		cnt = cnt.replace(/-->/g, "</comment>")
		
		var oldPath = navTreeOper.getPathInfo(crnode); // old path
		crnode.title = ttl;
		crnode.alias = als == undefined ? "" : filter(als);
		crnode.url = url == undefined ? "" : url;
		crnode.info_text = ift == undefined ? "" : ift;
		crnode.path = navTreeOper.getPathInfo(crnode); // with new filename!
		if($("#chkQuickLink:checked").length > 0) {
			crnode.quicklink = true;
		} else {
			crnode.quicklink = false;
		}
		$.post("app/update_contents.php", {
			"json_oper": "set_contents",
			"json_data": JSON.stringify(crnode),
			"content_html": cnt,
			"old_path": oldPath
		}, updateContentsCallback);
	});
	
	$("#btnRecovery").click(function() {
		doRecovery();
	});
});
// -->
</script>
</head>

<body onload="btnStartClick();">
<div id="wrapper">
	<h1 id="header">RRZE NavEditor 2.0 - Prototype</h1>
	<div id="navBar">
		<script type="text/javascript" src="js/page_nav.js"></script>
	</div>
	
	<div id="dirTreePanel">
		<fieldset>
			<legend>NavTree bearbeiten</legend>
			<label>Mit Template:</label>
			<select id="selTempl" name="selTempl" class="textBox">
				<option selected="selected" value="seitenvorlage.html">Normal</option>
				<option value="news.shtml">News</option>
				<option value="mitarbeiterliste.shtml">Mitarbeiter</option>
				<option value="organigramm.shtml">Organigramm</option>
			</select>
			<div style="margin:0.25em 0 0 0;"></div>
			<input type="button" id="btnAddSibling" value="Geschwister" class="button" title="Neuen Geschwisterknoten (unten) erstellen" />
			<input type="button" id="btnAddChild" value="Kind" class="button" title="Neuen Kindkonten (an der letzten Position) erstellen" />
			|
			<!--<input type="button" id="btnCut" value="Abschneiden" class="button" />
			<input type="button" id="btnPaste0" value="Paste S." class="button" />
			<input type="button" id="btnPaste1" value="Paste C." class="button" />-->
			<input type="button" id="btnRemove" value="Entfernen" class="button" title="Jetzigen Knoten (Seite) l&ouml;schen" />
			|
			<input type="button" id="btnSaveTree" value="Save Tree" class="button" />
		</fieldset>
		
		<h4>Hauptmen&uuml;</h4>
		<div id="pnlNormal"></div>
		
		<h4>Zielgruppe- und Direktlinks <a href="javascript:;" id="btnNewExtraNode" style="display:none;">[neu...]</a></h4>
		<div id="pnlExtra"></div>
		
		<h4>Technisches Men&uuml; <a href="javascript:;" id="btnNewSpecNode" style="display:none;">[neu...]</a></h4>
		<div id="pnlSpec"></div>
	</div>
	<div id="contentPanel">
		<form action="" method="post" name="frmEdit" id="frmEdit">
			<fieldset>
				<legend>Inhalt bearbeiten</legend>
				<label for="txtTitle">Titel:</label>
				<input type="text" id="txtTitle" name="txtTitle" size="48" class="textBox" style="width:240px;" />
				
				<label for="txtAlias">Alias:</label>
				<input type="text" id="txtAlias" name="txtAlias" size="16" class="textBox" style="width:80px;" title="Ein Aliasname f&uuml;r diese Seite, gilt auch als Filename" />
				
				<p>
				<label for="txtContent">Inhalt:</label>
				[ <a href="app/upload_img.php" target="_blank">Bild/Datei hochladen...</a> ]
				[ <a id="lnkPreview" href="javascript:;">Seite aufrufen...</a> ]
				<br />
				<textarea id="txtContent" name="txtContent" cols="80" rows="25" class="textBox"></textarea>
				</p>
				
				<p>
				<label for="txtUrl">URL:</label>
				<input type="text" id="txtUrl" name="txtUrl" size="32" class="textBox" style="width:160px;" title="Wenn vorhanden, wird ein Link gezeigt, kein Inhalt n&ouml;tig." />
				
				<label for="txtInfotext">Infotext:</label>
				<input type="text" id="txtInfotext" name="txtInfotext" size="24" class="textBox" style="width:120px;" title="Kommentar der Seite" />
				</p>
				
				<label for="chkQuickLink">Zeigen in Quick-Links:</label>
				<input type="checkbox" id="chkQuickLink" name="chkQuickLink" value="Yes" />
				
				<hr size="1" noshade="noshade" />
				<input type="button" id="btnUpdate" name="btnUpdate" value="Update" class="button" />
			</fieldset>
			<fieldset>
				<legend>Recovery Options</legend>
				<label>Alte Versionen:</label>
				<select id="selOldVersions" class="textBox">
					<option value="0" selected="selected">-- Backup-Liste --</option>
				</select>
				<input type="button" id="btnRecovery" name="btnRecovery" class="button" value="Recover" />
			</fieldset>
		</form>
		<div id="debug">:-)</div>
	</div>
	
	<div id="footer">&copy; 2007-08 Ke.Chang@rrze.uni-erlangen.de</div>
</div>
</body>

</html>
